// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ZylIdleTimer.pas' rev: 6.00

#ifndef ZylIdleTimerHPP
#define ZylIdleTimerHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Forms.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Zylidletimer
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TIdleTimerKind { itApplication, itSystem };
#pragma option pop

class DELPHICLASS TCustomTimer;
class PASCALIMPLEMENTATION TCustomTimer : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	unsigned FInterval;
	HWND FWindowHandle;
	Classes::TNotifyEvent FOnTimer;
	bool FEnabled;
	void __fastcall UpdateTimer(void);
	void __fastcall SetInterval(unsigned Value);
	void __fastcall SetOnTimer(Classes::TNotifyEvent Value);
	void __fastcall WndProc(Messages::TMessage &Msg);
	void __fastcall SetEnabled(bool Value);
	
protected:
	__property unsigned Interval = {read=FInterval, write=SetInterval, default=1000};
	__property Classes::TNotifyEvent OnTimer = {read=FOnTimer, write=SetOnTimer};
	DYNAMIC void __fastcall Timer(void);
	
__published:
	__property bool Enabled = {read=FEnabled, write=SetEnabled, default=1};
	
public:
	__fastcall virtual TCustomTimer(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomTimer(void);
};


class DELPHICLASS TZylIdleTimer;
class PASCALIMPLEMENTATION TZylIdleTimer : public TCustomTimer 
{
	typedef TCustomTimer inherited;
	
private:
	bool FRegistered;
	unsigned FInterval;
	System::TDateTime FApplicationIdleStartDateTime;
	bool FApplicationIdleWasFired;
	bool FSystemIdleWasFired;
	TIdleTimerKind FKind;
	Classes::TNotifyEvent FOnIdle;
	Classes::TNotifyEvent FOnResume;
	double FVersion;
	bool __fastcall GetLastInputInfoA(Windows::PLastInputInfo plii);
	void __fastcall SetOnIdle(const Classes::TNotifyEvent Value);
	void __fastcall SetKind(TIdleTimerKind Value);
	bool __fastcall RunningInTheIDE(void);
	
protected:
	void __fastcall DoTimer(System::TObject* Sender);
	void __fastcall SetApplicationIdleStartDateTime(tagMSG &Msg, bool &Handled);
	
public:
	__property double Version = {read=FVersion};
	__fastcall virtual TZylIdleTimer(Classes::TComponent* AOwner);
	__fastcall virtual ~TZylIdleTimer(void);
	unsigned __fastcall GetSystemIdleTime(void);
	unsigned __fastcall GetApplicationIdleTime(void);
	void __fastcall ResetApplicationIdleTime(void);
	
__published:
	__property unsigned Interval = {read=FInterval, write=FInterval, default=5000};
	__property TIdleTimerKind Kind = {read=FKind, write=SetKind, nodefault};
	__property Classes::TNotifyEvent OnIdle = {read=FOnIdle, write=SetOnIdle};
	__property Classes::TNotifyEvent OnResume = {read=FOnResume, write=FOnResume};
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint Precision = 0xa;
extern PACKAGE void __fastcall Register(void);

}	/* namespace Zylidletimer */
using namespace Zylidletimer;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// ZylIdleTimer
